unit Sysres1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
	 Button1: TButton;
	 Button2: TButton;
	 Memo1: TMemo;
	 Timer1: TTimer;
	 procedure Button1Click(Sender: TObject);
	 procedure Button2Click(Sender: TObject);
	 procedure FormActivate(Sender: TObject);
	 procedure Timer1Timer(Sender: TObject);
  private
	 { Private declarations }
	OldUserFreePercent: longint;
	OldGDIFreePercent: longint;
	Changed: boolean;
	procedure CheckResources;
	procedure UpdateDisplay;
  public
	 { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses ToolHelp;

{$R *.DFM}

procedure TForm1.CheckResources;
var msg: string;
	HeapInfo: PSysHeapInfo;
begin
	new(HeapInfo);
	try
		with HeapInfo^ do begin
			dwSize := SizeOf(TSysHeapInfo);
		end;
		if not SystemHeapInfo( HeapInfo)then raise exception.create('Error calling SystemHeapInfo');
      changed := false;
		with HeapInfo^ do begin
			if wUserFreePercent <> OldUserFreePercent then Changed := true;
			if wGDIFreePercent <> OldGDIFreePercent then Changed := true;
			if changed then begin
				OldUserFreePercent := wUserFreePercent;
				OldGDIFreePercent  := wGDIFreePercent;
				UpdateDisplay;
			end;
		end;
	finally dispose(HeapInfo);
	end;
end;

procedure TForm1.UpdateDisplay;
begin
	Memo1.lines.clear;
	Memo1.lines.add(format('User Heap is %d%% free.', [OldUserFreePercent]));
	Memo1.lines.add(format('GDI Heap is %d%% free.',[OldGDIFreePercent]));
	Application.Title := format('%d%%,%d%%', [OldUserFreePercent, OldGDIFreePercent]);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
	Close;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
	CheckResources;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
	CheckResources;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
	CheckResources;
end;

end.
